"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HeadlessCmsContentEntry = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _appAdmin = require("@webiny/app-admin");
var _appHeadlessCms = require("@webiny/app-headless-cms");
var _reactRouter = require("@webiny/react-router");
var _ContentEntryGuard = require("./ContentEntryGuard");
var _ContentEntryLocker = require("./ContentEntryLocker");
var ContentEntry = _appHeadlessCms.ContentEntryEditorConfig.ContentEntry,
  SingletonContentEntry = _appHeadlessCms.ContentEntryEditorConfig.SingletonContentEntry;
var DisablePrompt = (0, _appAdmin.createGenericContext)("DisablePrompt");
var PromptDecorator = _reactRouter.Prompt.createDecorator(function (Original) {
  return function Prompt(props) {
    var _DisablePrompt$useHoo = DisablePrompt.useHook(),
      disablePrompt = _DisablePrompt$useHoo.disablePrompt;
    var when = disablePrompt === true ? false : props.when;
    return /*#__PURE__*/_react.default.createElement(Original, {
      message: props.message,
      when: when
    });
  };
});
var ContentEntryDecorator = ContentEntry.createDecorator(function (Original) {
  return function RecordLockingContentEntry() {
    var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      disablePrompt = _useState2[0],
      setDisablePrompt = _useState2[1];
    var _ContentEntry$useCont = ContentEntry.useContentEntry(),
      entry = _ContentEntry$useCont.entry,
      contentModel = _ContentEntry$useCont.contentModel,
      loading = _ContentEntry$useCont.loading;
    var _ContentEntryListConf = _appHeadlessCms.ContentEntryListConfig.ContentEntries.useContentEntriesList(),
      navigateTo = _ContentEntryListConf.navigateTo;
    /**
     * New entry does not have ID yet.
     */
    if (!entry?.id) {
      return /*#__PURE__*/_react.default.createElement(DisablePrompt.Provider, {
        disablePrompt: disablePrompt
      }, /*#__PURE__*/_react.default.createElement(Original, null));
    }
    /**
     * Continue with existing entry.
     */
    var props = {
      entry: entry,
      model: contentModel
    };
    return /*#__PURE__*/_react.default.createElement(_ContentEntryGuard.ContentEntryGuard, Object.assign({}, props, {
      loading: loading
    }), /*#__PURE__*/_react.default.createElement(_ContentEntryLocker.ContentEntryLocker, Object.assign({}, props, {
      onDisablePrompt: function onDisablePrompt(flag) {
        return setDisablePrompt(flag);
      },
      onEntryUnlocked: navigateTo
    }), /*#__PURE__*/_react.default.createElement(DisablePrompt.Provider, {
      disablePrompt: disablePrompt
    }, /*#__PURE__*/_react.default.createElement(Original, null))));
  };
});
var SingletonContentEntryDecorator = SingletonContentEntry.createDecorator(function (Original) {
  return function RecordLockingSingletonContentEntry() {
    var _useState3 = (0, _react.useState)(false),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      disablePrompt = _useState4[0],
      setDisablePrompt = _useState4[1];
    var _SingletonContentEntr = SingletonContentEntry.useSingletonContentEntry(),
      entry = _SingletonContentEntr.entry,
      contentModel = _SingletonContentEntr.contentModel,
      loading = _SingletonContentEntr.loading;
    var props = {
      entry: entry,
      model: contentModel
    };
    return /*#__PURE__*/_react.default.createElement(_ContentEntryGuard.ContentEntryGuard, Object.assign({}, props, {
      loading: loading
    }), /*#__PURE__*/_react.default.createElement(_ContentEntryLocker.ContentEntryLocker, Object.assign({}, props, {
      onDisablePrompt: function onDisablePrompt(flag) {
        return setDisablePrompt(flag);
      },
      onEntryUnlocked: function onEntryUnlocked() {
        // There's nowhere to go, since singleton entry doesn't have a list view.
      }
    }), /*#__PURE__*/_react.default.createElement(DisablePrompt.Provider, {
      disablePrompt: disablePrompt
    }, /*#__PURE__*/_react.default.createElement(Original, null))));
  };
});
var HeadlessCmsContentEntry = exports.HeadlessCmsContentEntry = function HeadlessCmsContentEntry() {
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(ContentEntryDecorator, null), /*#__PURE__*/_react.default.createElement(SingletonContentEntryDecorator, null), /*#__PURE__*/_react.default.createElement(_appAdmin.CompositionScope, {
    name: "cms.contentEntryForm"
  }, /*#__PURE__*/_react.default.createElement(PromptDecorator, null)));
};

//# sourceMappingURL=HeadlessCmsContentEntry.js.map